# Contributing

**Icicle (icicle.io)** is an open-source project and welcomes contributions from the community. Below are the guidelines to contributing to Icicle.

- Icicle is released under the [Apache 2.0 license](LICENSE). Any code or documentation you submit will be released under that license. If your contribution is substantial, we may ask that you sign a [Contributor License Agreement (CLA)](http://en.wikipedia.org/wiki/Contributor_License_Agreement).
- Please submit any [issues](issues) or [pull requests](pulls) through GitHub.
- All code must be [PSR-1](http://www.php-fig.org/psr/psr-1/) and [PSR-2](http://www.php-fig.org/psr/psr-2/) compliant.
- Please see the [git-flow cheatsheet](http://danielkummer.github.com/git-flow-cheatsheet/) for a guide on how pull requests should be structured.
    - Branches for features should be made from the *development* branch. Branches for bug-fixes should be made from the *master* branch. All pull requests should be submitted to the *development* branch.
    - Please ensure that all tests pass before submitting a pull request. If you make changes to the code, please add, update, or remove unit tests as needed.
- If you'd like to implement a significant new feature, please contact us beforehand to avoid any duplication of effort.
